<!DOCTYPE html>
<!--
To change this license header, choose License Headers in Project Properties.
To change this template file, choose Tools | Templates
and open the template in the editor.
-->
<html>
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=utf-8">  
        <meta content="IE=edge" http-equiv="X-UA-Compatible"> 
        <meta content="width=device-width,initial-scale=1" name="viewport"> 
        <meta content="Aulas de introcução à computação científica." name="description"> 
        <meta content="Markinho" name="author"> 
        
        <title> Funções e ramificações </title> 
        
        <link href="./css/bootstrap.min.css" rel="stylesheet">        
        <link href="./css/docs.min.css" rel="stylesheet">
        <link href="./css/carbonads.css" rel="stylesheet">
        <link href="./css/prism.css" rel="stylesheet">
        
        <link href="../imagens/favicon.ico" rel="icon"> 
        
        <script type="text/x-mathjax-config">
            MathJax.Hub.Config({tex2jax: {inlineMath: [['$','$'], ['\\(','\\)']]}});
        </script>
        <script type="text/javascript" async
            src="https://cdn.mathjax.org/mathjax/latest/MathJax.js?config=TeX-AMS_CHTML">
        </script>
        
    </head>
    <body>
        
        <!-- Cabeçalho -->
        <div class="v4-tease">
            <a href="http://www.estruturas.ufpr.br">
                <img style="position: absolute; top: 0; left: 0; border: 0;" 
                     src="../imagens/estruturasUFPR.png" alt="Voltar para Estruturas.UFPR">
            </a>
            <a class="navbar-brand" style="position: absolute; left: 360px;" href="../index.html">
                Aulas de Introdução a Computação Científica
            </a>
        </div>
         <!-- FINAL Cabeçalho -->
        
        <!-- Menu superior -->
        <header class="bs-docs-nav navbar navbar-static-top" id="top"> 
            <div class="container"> 
                <div class="navbar-header"> 
                    <button aria-controls="bs-navbar"  
                            class="collapsed navbar-toggle" data-target="#bs-navbar" 
                            data-toggle="collapse" type="button"> 
                        <span class="sr-only">Alternar Navegação</span> 
                        <span class="icon-bar"></span> 
                        <span class="icon-bar"></span> 
                        <span class="icon-bar"></span> 
                    </button>
                </div> 
                <nav class="collapse navbar-collapse" id="bs-navbar"> 
                    <ul class="nav navbar-nav"> 
                        <li class="active"> <a href="lacoslistas.html">Funções e ramificações</a> </li>
                        <li><a href="#final">Tarefa</a></li>
                    </ul> 
                    <ul class="nav navbar-nav navbar-right"> 
                        <li class="dropdown" id="accountmenu">
                            <a class="dropdown-toggle" data-toggle="dropdown" href="#">Demais tópicos abordados<b class="caret"></b></a>
                            <ul class="dropdown-menu">
                                <li><a href="../index.html#___sec0">Programando equações</a></li>
                                <li><a href="../index.html#___sec1">Laços e listas</a></li>
                                <li><a href="../index.html#___sec2">Funções e ramificações</a></li>
                                <li><a href="../index.html#___sec3">Entrada do usuário e manipulação de erros</a></li>
                                <li><a href="../index.html#___sec4">Arranjos e gráficos de curvas</a></li>            
                                <li><a href="../index.html#___sec6">Dicionários e cadeias de caracteres</a></li>
                                <li><a href="../index.html#___sec7">Introdução a Classes</a></li>            
                                <li><a href="../index.html#___sec9">Programação orientada a objeto</a></li>
                                <li><a href="../index.html#___sec10">Números aleatórios e jogos simples</a></li>
                                <li><a href="../index.html#___secA">Sequências e relações de recorrência</a></li>
                                <li><a href="../index.html#___secB">Programação de equações diferenciais</a></li>
                                <li><a href="../index.html#___secC">Gráficos tridimensionais</a></li>
                                <li><a href="../index.html#___secD">Programação em paralelo</a></li>
                                <li><a href="../index.html#___secE">Interfaces gráficas de usuário (GUI)</a></li>
                                <li><a href="../index.html#___secF">Migrando Python para código compilado</a></li> 
                            </ul>
                        </li> 
                    </ul> 
                </nav> 
            </div> 
        </header>
        <!-- FINAL MENU SUPERIOR -->
        
        <!-- Painel Superior -->
        <div class="bs-docs-header" id="content" tabindex="-1"> 
            <div class="container"> 
                <h1>Funções e ramificações</h1> 
                <p>Se sim, faça isso, se não, faça aquilo.<br>
                <font size="2px">Prof. Marco André Argenta / PPGECC / UFPR</font></p>
                <div id="carbonads-container">
                    <div class="carbonad">
                        <div id="azcarbon">
                            <a href="./imagens/programando_equacoes.png" target="_blank">
                                <!-- Imagens em 120 px altura e 300 px largura -->
                                <img src="./imagens/funcoesramificacoes.png" class="carbonad-image carbonad-img">
                            </a>
                        </div>
                    </div>
                </div> 
            </div> 
        </div>
        <!-- FINAL PAINEL SUPERIOR -->
        
        <!-- Parte principal -->
        <div class="container bs-docs-container">
            <div class="row">
                
                <!-- Conteúdo Principal -->
                <div class="col-md-9" role="main">
                    <div class="bs-docs-section"> 
                        <h1 class="page-header" id="inicio">Funções e Ramificações</h1> 
                        <div class="well">
                            Introduzindo dois conceitos fundamentais e extremamente úteis
                            na programação: funções definidas pelo programador e 
                            ramificação do fluxo do programa, o último também conhecido
                            como testes <code>if</code>.
                        </div>               
                    </div>
                    <div class="bs-docs-section" id="funcoes_usadas">
                        <h1 class="page-header">Já usamos várias funções em Python</h1>

                        <p>Funções matemáticas:</p>
                        <pre><code class="language-python">
import math
y = math.sin(x)*math.log(x)
                        </code></pre>
                        
                        <p>Outras funções:</p>
                        <pre><code class="language-python">
n = len(algumalista)
inteiros = range(5, n, 2)
                        </code></pre>
                        
                        <p>Funções utilizadas com a sintaxe "ponto" 
                            (chamadas métodos):</p>
                        <pre><code class="language-python">
C = [5, 10, 40, 45]
i = C.index(10)        # resultado: i=1
C.append(50)
C.insert(2, 20)
                        </code></pre>
                        
                        <p>Mas, o que é uma função?</p>
                        <p>Até então nos colocamos objetos nessas funções e 
                        recebemos outro objeto delas.
                        </p>
                        <p>Agora é hora de escrever nossas próprias funções!</p>                        
                    </div>
                    <div class="bs-docs-section" id="import_funcoes">
                        <h1 class="page-header">Funções são importantes</h1>

                        <p>Funções são uma das mais importantes ferramentas
                        em programanção.</p>
                        
                        <ul>
                            <li>Função = uma coleção de declarações que
                            podemos executar onde e quando quisermos;</li>
                            <li>Uma função pode receber objetos de entrada
                            (os argumentos) e produzir objetos de saída
                            (os resultados retornados);</li>
                            <li>Funções ajudam a organizar programas, fazem deles
                            mais fáceis de entender, curtos, reusáveis e fáceis
                            de se extender.</li>
                        </ul>                        
                    </div>
                    <div class="bs-docs-section" id="funcao_python">
                        <h1 class="page-header">Funções em Python</h1>

                        <p>Função em Python para implementar uma função
                        matemática:</p>
                        
                        $$ F(C)=\dfrac{9}{5}C+32 $$
                        
                        <p>pode ser implementada em Python como:</p>
                        <pre><code class="language-python">
def F(C):
    return (9.0/5)*C + 32
                        </code></pre>
                        
                        <p>Notas:</p>
                        <ul>
                            <li>Funções iniciam com <code>def</code>, seguido do
                            nome da função e uma lista de argumentos (no caso 
                            <code>C</code>), esse é o cabeçalho da função;</li>
                            <li>Dentro da função: declarações, essas são o
                            corpo da função;</li>
                            <li>Sempre que quisermos, dentro da função, podemos 
                            "parar a função" e retornar quantos valores/variáveis
                            quisermos.</li>
                        </ul>
                    </div>
                    <div class="bs-docs-section" id="chamando_funcoes">
                        <h1 class="page-header">Funções devem ser chamadas</h1>

                        <p>Uma função não faz nada até ser chamada.</p>
                        
                        <iframe width="800" height="400" frameborder="0" 
                                src="http://pythontutor.com/iframe-embed.html#code=def%20F%28C%29%3A%0A%20%20%20%20return%20%289.0/5%29*C%20%2B%2032%0A%0Aa%20%3D%2010%0AF1%20%3D%20F%28a%29%20%20%20%20%20%20%20%20%20%20%20%20%20%20%20%20%20%20%20%20%20%20%20%20%20%20%20%20%20%20%23%20chamada%0Atemp%20%3D%20F%2815.5%29%20%20%20%20%20%20%20%20%20%20%20%20%20%20%20%20%20%20%20%20%20%20%20%20%20%23%20chamada%0Aprint%20F%28a%2B1%29%20%20%20%20%20%20%20%20%20%20%20%20%20%20%20%20%20%20%20%20%20%20%20%20%20%20%20%23%20chamada%0Asoma_temp%20%3D%20F%2810%29%20%2B%20F%2820%29%20%20%20%20%20%20%20%20%20%20%20%20%20%20%20%23%20duas%20chamadas%0AFgraus%20%3D%20%5BF%28C%29%20for%20C%20in%20%5B0,%2020,%2040%5D%5D%20%23%20multiplas%20chamadas&codeDivHeight=400&codeDivWidth=350&cumulative=false&curInstr=0&heapPrimitives=false&origin=opt-frontend.js&py=2&rawInputLstJSON=%5B%5D&textReferences=false"> 
                        </iframe>
                        
                        <p>Nota: A chamada <code>F(C)</code> produz (retorna)
                            um objeto <code>float</code>, o que significa que
                            <code>F(C)</code> é substituído por esse objeto de ponto
                            flutuante. Podemos, então, fazer a chamada de <code>F(C)</code>
                            em qualquer lugar onde um <code>float</code> pode ser
                            utilizado.</p>                        
                    </div>
                    <div class="bs-docs-section" id="funcoes_argumentos">
                        <h1 class="page-header">Argumentos de Funções</h1>

                        <p>Funções podem ter quantos argumentos quisermos.</p>
                        <p>Faça um função em Python da função matemática:</p>
                        
                        $$ y(t) = v_0t- \frac{1}{2}gt^2$$
                        
                        <iframe width="800" height="400" frameborder="0" 
                                src="http://pythontutor.com/iframe-embed.html#code=def%20yfunc%28t,%20v0%29%3A%0A%20%20%20%20g%20%3D%209.81%0A%20%20%20%20return%20v0*t%20-%200.5*g*t**2%0A%0A%23exemplos%20de%20chamadas%3A%0Ay%20%3D%20yfunc%280.1,%206%29%0Ay%20%3D%20yfunc%280.1,%20v0%3D6%29%0Ay%20%3D%20yfunc%28t%3D0.1,%20v0%3D6%29%0Ay%20%3D%20yfunc%28v0%3D6,%20t%3D0.1%29&codeDivHeight=400&codeDivWidth=350&cumulative=false&curInstr=0&heapPrimitives=false&origin=opt-frontend.js&py=2&rawInputLstJSON=%5B%5D&textReferences=false"> 
                        </iframe>                        
                    </div>
                    <div class="bs-docs-section" id="funcoes_argumentos_locais">
                        <h1 class="page-header">Argumentos dentro da função</h1>

                        <p>Os argumentos se tornam variáveis locais dentro da função.</p>
                        
                        <iframe width="800" height="330" frameborder="0" 
                                src="http://pythontutor.com/iframe-embed.html#code=def%20yfunc%28t,%20v0%29%3A%0A%20%20%20%20g%20%3D%209.81%0A%20%20%20%20return%20v0*t%20-%200.5*g*t**2%0A%0Av0%20%3D%205%0At%20%3D%200.6%0Ay%20%3D%20yfunc%28t,%203%29&codeDivHeight=400&codeDivWidth=350&cumulative=false&curInstr=0&heapPrimitives=false&origin=opt-frontend.js&py=2&rawInputLstJSON=%5B%5D&textReferences=false"> 
                        </iframe>
                        
                        <p><b>Variáveis locais X Variáveis globais</b></p>
                        <p>Quando chamamos <code>yfunc(t, 3)</code>, todas essas
                        declarações são de fato executadas:</p>
                        
                        <pre><code class="language-python">
t = 0.6  #aos argumentos são atribuídos valores assim como na atribuição padrão
v0 = 3
g = 9.81
return v0*t - 0.5*g*t**2
                        </code></pre>
                        
                        <p>Dentro da <code>yfunc</code>, <code>t</code>,
                            <code>v0</code> e <code>g</code> são variáveis
                            locais, não visíveis fora de <code>yfunc</code>
                            e destruídas após o <code>return</code>.</p>
                        <p>Fora de <code>yfunc</code> (no programa principal)
                        <code>t</code>, <code>v0</code> e <code>y</code>
                        são variáveis globais, visíveis em qualquer lugar.</p>
                        
                    </div>
                    <div class="bs-docs-section" id="funcoes_global_var">
                        <h1 class="page-header">Funções e variáveis globais</h1>

                        <p>Funções podem acessar variáveis globais.</p>
                        <p>A função <code>yfunc(t, v0)</code> possui 2 argumentos.
                            E se escrevessemos apenas com um, <code>t</code>:</p>
                        
                        <pre><code class="language-python">
>>> def yfunc(t):
...     g = 9.81
...     return v0*t - 0.5*g*t**2
...
>>> t = 0.6
>>> yfunc(t)
...
NameError: global name 'v0' is not defined
                        </code></pre>
                        
                        <p>Problema> <code>v0</code> deve ser definido antes 
                            da chamada de <code>yfunc</code>!</p>
                        
                        <pre><code class="language-python">
>>> def yfunc(t):
...     g = 9.81
...     return v0*t - 0.5*g*t**2
...
>>> t = 0.6
>>> v0 = 5
>>> yfunc(0.6)
1.2342
                        </code></pre>
                        
                        <p>Nota: <code>v0</code> e <code>t</code> (no programa
                            principal) são variáveis globais, enquanto que <code>t</code>
                            dentro da função <code>yfunc</code> é uma variável local.</p>
                        
                    </div>
                    <div class="bs-docs-section" id="var_local_global">
                        <h1 class="page-header">Variáveis locais e globais de mesmo nome</h1>

                        <p>Variáveis locais se sobrepõe às variáveis globais de mesmo nome.</p>
                        <p>Teste o seguinte:</p>
                        
                        <iframe width="800" height="500" frameborder="0" 
                                src="http://pythontutor.com/iframe-embed.html#code=def%20yfunc%28t%29%3A%0A%20%20%20%20print%20'1.%20t%20local%20dentro%20de%20yfunc%3A',%20t%0A%20%20%20%20g%20%3D%209.81%0A%20%20%20%20t%20%3D%200.1%0A%20%20%20%20print%20'2.%20t%20local%20dentro%20de%20yfunc%3A',%20t%0A%20%20%20%20return%20v0*t%20-%200.5*g*t**2%0A%0At%20%3D%200.6%0Av0%20%3D%202%0Aprint%20yfunc%28t%29%0Aprint%20'1.%20t%20global%3A',%20t%0Aprint%20yfunc%280.3%29%0Aprint%20'2.%20t%20global%3A',%20t&codeDivHeight=400&codeDivWidth=350&cumulative=false&curInstr=0&heapPrimitives=false&origin=opt-frontend.js&py=2&rawInputLstJSON=%5B%5D&textReferences=false"> 
                        </iframe>
                        
                        <div class="alert alert-warning" role="alert">
                            <b>Pergunta:</b>
                            <p>
                            O que foi mostrado nos <code>print</code>?
                        </div>
                        
                    </div>
                    <div class="bs-docs-section" id="var_glob_mud_func">
                        <h1 class="page-header">Modificar variáveis globais na função</h1>

                        <p>Variáveis globais podem ser modificadas se declaradas
                        como globais na função.</p>
                        
                        <iframe width="800" height="400" frameborder="0" 
                                src="http://pythontutor.com/iframe-embed.html#code=def%20yfunc%28t%29%3A%0A%20%20%20%20g%20%3D%209.81%0A%20%20%20%20global%20v0%20%20%20%23%20agora%20v0%20pode%20ser%20modificado%20dentro%20da%20fun%C3%A7%C3%A3o%0A%20%20%20%20v0%20%3D%209%0A%20%20%20%20return%20v0*t%20-%200.5*g*t**2%0A%0Av0%20%3D%202%20%20%20%23vari%C3%A1vel%20global%0Aprint%20'1.%20v0%3A',%20v0%0Aprint%20yfunc%280.8%29%0Aprint%20'2.%20v0%3A',%20v0&codeDivHeight=400&codeDivWidth=350&cumulative=false&curInstr=0&heapPrimitives=false&origin=opt-frontend.js&py=2&rawInputLstJSON=%5B%5D&textReferences=false"> 
                        </iframe>
                        
                        <p><b>O que foi mostrado?</b></p>
                        <pre>
1. v0: 2
4.0608
2. v0: 9
                        </pre>
                        <p><b>O que aconteceria de comentássemos a linha <code>global v0</code>?</b></p>
                        <pre>
1. v0: 2
4.0608
2. v0: 2
                        </pre>
                        
                        <p><code>v0</code> em <code>yfunc</code> se torna uma 
                        variável local.</p>
                        
                    </div>
                    <div class="bs-docs-section" id="funcoes_mult_val">
                        <h1 class="page-header">Funções podem retornar
                        múltiplos valores</h1>

                        <p>Digamos que queremos calcular \( y(t) \) e \( y'(t)=v_0-gt \):</p>
                        
                        <pre><code class="language-python">
def yfunc(t, v0):
    g = 9.81
    y = v0*t - 0.5*g*t**2
    dydt = v0 - g*t
    return y, dydt

#chamada:
posicao, velocidade = yfunc(0.6, 3)
                        </code></pre>
                        
                        <p>Separe os objetos a serem retornados por vírgulas e
                        os atribua a variáveis também separadas por vírgulas.
                        Na verdade, uma tupla é retornada:</p>
                        
                        <pre><code class="language-python">
>>> def f(x):
...     return x, x**2, x**4
...
>>> s = f(2)
>>> s
(2, 4, 16)
>>> type(s)
<type 'tuple'>
>>> x, x2, x4 = f(2)
                        </code></pre>
                        
                    </div>
                    <div class="bs-docs-section" id="ex_soma">
                        <h1 class="page-header">Exemplo</h1>

                        <p>Calcule uma função definida como uma somatória:</p>
                        
                        $$ L(x,n) = \sum_{i=1}^n {1\over i}\left( {x\over 1+x}\right)^{i} $$
                        
                        <p>Essa função é uma aproximação de \( \ln (1+x) \) para  
                        \( n \) finito e \( x\geq 1 \).</p>
                        
                        <p>Correspondente função em python para \( L(x,n) \):</p>
                        
                        <pre><code class="language-python">
import math

def L(x, n):
    x = float(x)  #garantindo a divisão abaixo em ponto flutuante
    s = 0
    for i in range(1, n+1):
        s += (1.0/i)*(x/(1+x))**i
    return s

x = 5

print L(x, 10), L(x, 100), math.log(1+x)
                        </code></pre>                        
                    </div>
                    <div class="bs-docs-section" id="erros_funcao">
                        <h1 class="page-header">Retornando os erros da função $ L(x, n) $</h1>

                        <p>Podemos retornar mais:</p>
                        <ol>
                            <li>O primeiro termo negligenciado na soma;</li>
                            <li>O erro (\( \ln (1+x) - L(x,n) \))</li>
                        </ol>
                        
                        <pre><code class="language-python">
import math

def L2(x, n):
    x = float(x)
    s = 0
    for i in range(1, n+1):
        s += (1.0/i)*(x/(1+x))**i
    valor_soma = s
    prim_term_negl = (1.0/(n+1))*(x/(1+x))**(n+1) #truncado
    erro_exato = math.log(1+x) - valor_soma
    return valor_soma, prim_term_negl, erro_exato

#chamada típica:
x = 1.2; n = 100
valor, erro_aproximado, erro_exato = L2(x, n)
                        </code></pre> 
                        
                    </div>
                    <div class="bs-docs-section" id="funcao_sem_retorno">
                        <h1 class="page-header">Funções não precisam retornar objetos</h1>
                        
                        <pre><code class="language-python">
def algumafunc(obj):
    print obj

valor_retorno = algumafunc(3.4)
                        </code></pre> 

                        <p>Aqui <code>valor_retorno</code> se torna <code>None</code> porque 
                        não retornamos nada da função explicitamente, Python vai inserir
                        <code>return None</code>.</p>
                        
                    </div>
                    <div class="bs-docs-section" id="funcao_sem_retorno_ex">
                        <h1 class="page-header">Exemplo de uma função sem valor de retorno</h1>

                        <p>Faça uma tabela de $ L(x, n) $ X $ ln(1+x) $</p>
                        
                        <pre><code class="language-python">
def tabela(x):
    print '\nx=%g, ln(1+x)=%g' % (x, math.log(1+x))
    for n in [1, 2, 10, 100, 500]:
        valor, prox, erro = L2(x, n)
        print 'n=%-4d %-10g  (próximo termo: %8.2e  '\
              'erro: %8.2e)' % (n, valor, prox, erro)

#chamada:
tabela(x)
                        </code></pre>
                        
                        <p>Não há a necessidade de retornar nada aqui, o propósito
                        é imprimir.</p>
                        
                        <pre><code class="language-bash">
x=10, ln(1+x)=2.3979
n=1    0.909091    (próximo termo: 4.13e-01  erro: 1.49e+00)
n=2    1.32231     (próximo termo: 2.50e-01  erro: 1.08e+00)
n=10   2.17907     (próximo termo: 3.19e-02  erro: 2.19e-01)
n=100  2.39789     (próximo termo: 6.53e-07  erro: 6.59e-06)
n=500  2.3979      (próximo termo: 3.65e-24  erro: 6.22e-15)
                        </code></pre>
                        
                    </div>
                    <div class="bs-docs-section" id="funcoes_argumentos_chave">
                        <h1 class="page-header">Agrumentos palavra-chave</h1>

                        <p>Os argumentos palavra-chave (keyword) são úteis para
                        simplificar a chamada de funções e ajudar a documentar
                        os argumentos.</p>
                        <p>Esses argumentos são escritos na forma <code>nome = valor</code>:</p>
                        
                        <pre><code class="language-python">
def algumafunc(arg1, arg2, pcarg1 = True, pcarg2 = 0):
    print arg1, arg2, pcarg1, pcarg2
                        </code></pre>
                        
                    </div>
                    <div class="bs-docs-section" id="funcoes_argumentos_chave_ex">
                        <h1 class="page-header">Exemplos chamando funções com palavra-chave</h1>

                        <pre><code class="language-python">
>>> def algumafunc(arg1, arg2, pcarg1 = True, pcarg2 = 0):
>>>     print arg1, arg2, pcarg1, pcarg2

>>> algumafunc('Bom dia', [1,2])   #sem pcarg1 e pcarg2
Bom dia [1, 2] True 0            #valores padrões são usados

>>> algumafunc('Bom dia', [1,2], pcarg1 = 'Oi')
Bom dia [1, 2] Oi 0              #pcarg2 permanece com o valor padrão

>>> algumafunc('Bom dia', [1,2], pcarg2 = 'Oi')
Bom dia [1, 2] True Oi           # pcarg1 permanece com o valor padrão

>>> algumafunc('Bom dia', [1,2], pcarg2 = 'Oi', pcarg1 = 6)
Bom dia [1, 2] 6 Oi              #todos os argumentos especificados
                        </code></pre>
                        
                        <p>Se usarmos <code>nome = valor</code> para todos os 
                        argumentos na chamada da função, sua sequencia pode ser
                        arbitrária:</p>
                        
                        <pre><code class="language-python">
>> algumafunc(pcarg2 = 'Bom dia', arg1 = 'Oi', pcarg1 = 6, arg2 = [2])
Oi [2] 6 Bom dia
                        </code></pre>
                    </div> 
                    <div class="bs-docs-section" id="func_uma_var_add">
                        <h1 class="page-header">Função matemática com uma variável e parâmetros
                        adicionais</h1>

                        <p>Como implementar uma função matemática de uma variável, mas com 
                            parâmetros adicionais?</p>
                        <p>Considere a função de $ t $, com parâmetros $ A $,
                            $ a $ e $ \omega $:</p>
                        
                        $$ f(t; A,a, \omega) = Ae^{-at}\sin (\omega t) $$
                        
                        <p>Uma possível implementação seria uma função Python com
                        a variável $ t $ como argumento posicional e $ A $,
                            $ a $ e $ \omega $ como argumentos palavra-chave:</p>
                        
                        <pre><code class="language-python">
import math

def f(t, A=1, a=1, omega=2*math.pi):
    return A*math.exp(-a*t)*math.sin(omega*t)

v1 = f(0.2)
v2 = f(0.2, omega=1)
v2 = f(0.2, 1, 3)  #o mesmo que f(0.2, A=1, a=3)
v3 = f(0.2, omega=1, A=2.5)
v4 = f(A=5, a=0.1, omega=1, t=1.3)
v5 = f(t=0.2, A=9)
v6 = f(t=0.2, 9)   #ilegal: palavra-chave antes do posicional
                        </code></pre>
                        
                    </div>  
                    <div class="bs-docs-section" id="documentacao_funcao">
                        <h1 class="page-header">Documentando uma função <i>Doc Strings</i></h1>

                        <p><b>Importante convenção do Python:</b></p>
                        
                        <p>Documente o propósito da função, seus argumentos e seus valores
                            de retorno em uma <i>doc string</i>, uma cadeia de caracteres
                        entre triplas aspas escrita logo após o cabeçalho da função.</p>
                        
                        <pre><code class="language-python">
def C2F(C):
    """Converte graus Celsius (C) para Fahrenheit."""
    return (9.0/5)*C + 32

def linha(x0, y0, x1, y1):
    """
    Calcula os coeficientes a e b na expressão
    matemática para uma linha reta y = a*x + b entre
    dois pontos (x0, y0) e (x1, y1).

    x0, y0: um ponto na linha (pontos flutuantes).
    x1, y1: outro ponto na linha (pontos flutuantes).
    retorno: a, b (pontos flutuantes) para a linha (y=a*x+b).
    """
    a = (y1 - y0)/(x1 - x0)
    b = y0 - a*x0
    return a, b
                        </code></pre>
                        
                    </div>
                    <div class="bs-docs-section" id="convencao_entrada_saida">
                        <h1 class="page-header">Convenção de entrada e saída em Python</h1>

                        <p>Entrada (<i>input</i>) são os argumentos da função, saída
                            (<i>output</i>) são os valores retornados.</p>
                        <ul>
                            <li>Uma função pode ter três tipos de dados de entrada e saída:
                                <ul>
                                    <li>dados de entrada especificados através de argumentos
                                    posicionais ou palavra-chave;</li>
                                    <li>dados de entrada/saída dados como argumentos
                                    posicionais/palavra-chave que serão modificados
                                    e retornados;</li>
                                    <li>dados de saída criados dentro da função.</li>
                                </ul>
                            </li>
                            <li>Todos os dados de saída são retornados e todos
                            os dados de entrada são argumentos.</li>
                        </ul>
                        
                        <pre><code class="language-python">
def algumafunc(i1, i2, i3, io4, io5, i6 = valor1, io7 = valor2):
    #modifica io4, io5, io7; calcula o1, o2, o3
    return o1, o2, o3, io4, io5, io7
                        </code></pre>
                        
                        <p>Os argumentos da função são:</p>
                        <ul>
                            <li>entrada pura: <pre>i1, i2, i3, i6</pre></li>
                            <li>entrada e saída: <pre>io4, io5, io7</pre></li>
                        </ul>
                        
                    </div>
                    <div class="bs-docs-section" id="fora_funcao">
                        <h1 class="page-header">O programa principal é uma série de 
                        declarações fora de funções</h1>

                        <pre><code class="language-python">
import math         #no principal

def f(x):                   #no principal
    e = math.exp(-0.1*x)
    s = math.sin(6*pi*x)
    return e*s

x = 2                       #no principal
y = f(x)                    #no principal
print 'f(%g)=%g' % (x, y)   #no principal
                        </code></pre>
                        
                        <p>A execução inicia com a primeira declaração no programa
                        principal e continua linha por linha, de cima abaixo.</p>
                        <p>Declarações <code>def</code> definem uma função, mas as
                        declarações dentro da função somente são executadas
                        quando a função é chamada.</p>
                        
                    </div>
                    <div class="bs-docs-section" id="funcoes_argumentos_funcoes">
                        <h1 class="page-header">Funções Python como argumentos de 
                        funções Pythom</h1>

                        <p>Programas fazendo cálculos frequentes necessitam de
                        funções como argumentos de outras funções, exemplo:</p>
                        <ul>
                            <li>Integração numérica: \( \int_a^b f(x)dx \)</li>
                            <li>Diferenciação numérica: \( f'(x) \)</li>
                            <li>Determinação de raízes numérica: \( f(x)=0 \)</li>
                        </ul>
                        
                        <p>Todos esses casos precisam de \( f \) como uma função
                        Python <code>f(x)</code>.</p>
                        
                        <p><b>Exemplo: cálculo numérico de \( f''(x) \):</b></p>
                        
                        $$ f''(x) \approx {f(x-h) - 2f(x) + f(x+h)\over h^2} $$

                        <pre><code class="language-python">
def dif2(f, x, h=1E-6):
    r = (f(x-h) - 2*f(x) + f(x+h))/float(h*h)
    return r
                        </code></pre>
                        
                        <p>Nenhuma dificuldade com $ f $ sendo uma função (bem mais
                        complicado em outras linguagens).</p>
                        
                    </div>
                    <div class="bs-docs-section" id="aplicacao_dif2">
                        <h1 class="page-header">Aplicação da função <code>dif2</code></h1>

                        <div class="alert alert-danger" role="alert">
                            VEJA A SAÍDA COM ATENÇÃO!!!
                        </div>
                        
                        <p>Código:</p>
                        
                        <pre><code class="language-python">
def g(t):
    return t**(-6)

#faz uma tabela de g''(t) para 13 valores de h:
for k in range(1,14):
    h = 10**(-k)
    print 'h=%.0e: %.5f' % (h, dif2(g, 1, h))
                        </code></pre>
                        
                        <p>Saída (\( g''(1)=42 \)):</p>
                        
                        <pre><code class="language-bash">
h=1e-01: 44.61504
h=1e-02: 42.02521
h=1e-03: 42.00025
h=1e-04: 42.00000
h=1e-05: 41.99999
h=1e-06: 42.00074
h=1e-07: 41.94423
h=1e-08: 47.73959
h=1e-09: -666.13381
h=1e-10: 0.00000
h=1e-11: 0.00000
h=1e-12: -666133814.77509
h=1e-13: 66613381477.50939
                        </code></pre>
                        
                    </div>
                    <div class="bs-docs-section" id="erros_arredondamento_tabela">
                        <h1 class="page-header">Erros de arredondamento causados por
                        valores sem sentido na tabela</h1>

                        <ul>
                            <li>Para \( h < 10^{-8} \) os resultados estão totalmente
                            errados!</li>
                            <li>Esperaríamos melhores aproximações quando \( h \)
                            se torna menor;</li>
                            <li>Problema 1: para \( h \) pequenos subtraímos 
                            números de tamanho aproximado e isso gera os
                            erros de arredondamento;</li>
                            <li>Problema 2: para \( h \) pequenos os erros de
                            arredondamento são multiplicados por um número grande;</li>
                            <li>Solução: usar variáveis do tipo ponto flutuante com
                            mais dígitos;</li>
                            <li>O Python tem um tipo de ponto flutuante (lento)
                            (<code>decimal.Decimal</code>) com um número arbitrário
                            de dígitos;</li>
                            <li>Usando 25 dígitos chegamos a resultados precisos 
                            para \( h \leq 10^{-13} \);</li>
                            <li>Mas, isso é realmente um problema? Raramente. Outras
                            incertezas nos dados de entrada para um cálculo matemático
                            fazem ter usualmente (por exemplo) \( 10^{-2}\leq h \leq 10^{-6} \)</li>
                        </ul>
                         <pre><code class="language-python">
import decimal                  #pontos flutuantes com número de dígitos arbitrários
decimal.getcontext().prec = 25  #usando 25 dígitos
D = decimal.Decimal             #forma curta de uma noto tipo de ponto flutuante

def dif2(f, x, h=1E-9):
    x = D(str(x));  h = D(str(h))  #convertendo para alta precisão, precisa ser string
    r = (f(x-h) - 2*f(x) + f(x+h))/(h*h)
    return r

def g(t):
    return t**(-6)

for k in range(1,15):
    h = 10**(-k)
    print 'h=%.0e: %.5f' % (h, dif2(g, 1, h))
                        </code></pre>
                        
                        <p>Saída:</p>
                        
                        <pre><code class="language-bash">
h=1e-01: 44.61504
h=1e-02: 42.02521
h=1e-03: 42.00025
h=1e-04: 42.00000
h=1e-05: 42.00000
h=1e-06: 42.00000
h=1e-07: 42.00000
h=1e-08: 42.00000
h=1e-09: 42.00000
h=1e-10: 42.00000
h=1e-11: 42.00000
h=1e-12: 42.00000
h=1e-13: 20.00000
h=1e-14: 0.00000
                        </code></pre>
                        
                    </div>
                    <div class="bs-docs-section" id="funcoes_lambda">
                        <h1 class="page-header">Funções <code>lambda</code></h1>

                        <p>Função <code>lambda</code> são utilizadas
                        para definições compactas de funções em linha, exemplo:</p>
                        
                        <pre><code class="language-python">
def f(x):
    return x**2 - 1
                        </code></pre>
                        
                        <p>A construção com <code>lambda</code> pode definir essa função em 
                        uma linha:</p>
                        
                        <pre><code class="language-python">
f = lambda x: x**2 - 1
                        </code></pre>
                        
                        <p>De forma geral:</p>
                        
                        <pre><code class="language-python">
algumafunc = lambda a1, a2, ...: alguma_expresssao
                        </code></pre>
                        
                        <p>O que é equivalente a:</p>
                        
                        <pre><code class="language-python">
def algumafunc(a1, a2, ...):
    return alguma_expressao
                        </code></pre>
                        
                        <p>Funções <code>lambda</code> podem ser usadas
                        diretamente como argumento na chama de funções:</p>
                        
                        <pre><code class="language-python">
valor = algumaOutraFunc(lambda x, y, z: x+y+3*z, 4)
                        </code></pre>
                        
                    </div>
                    <div class="bs-docs-section" id="funcoes_lambda_ex">
                        <h1 class="page-header">Exemplo do uso de uma função 
                            <code>lambda</code> para poupar tempo</h1>

                        <p>Código padrão de funções:</p>
                        
                        <pre><code class="language-python">
def g(t):
    return t**(-6)

dgdt = dif2(g, 2)
print dgdt
                        </code></pre>
                        
                        <p>Versão mais compacta com <code>lambda</code>:</p>
                        
                        <pre><code class="language-python">
dgdt = dif2(lambda t: t**(-6), 2)
print dgdt
                        </code></pre>
                        
                    </div>
                    <div class="bs-docs-section" id="ramificacoes">
                        <h1 class="page-header">Ramificações no fluxo de
                            declarações com o <code>if</code></h1>

                        <p>Algumas vezes queremos fazer ações diferentes
                        dependendo de uma condição. Exemplo:</p>
                        
                        $$
                        f(x) = \left\lbrace\begin{array}{ll}
                        \sen x, & 0\leq x\leq \pi\\
                        0, & \hbox{outros}
                        \end{array}\right.
                        $$
                        
                        <p>Uma implementação Python de $f$ precisa testar o valor
                        de $x$ e ramificar entre dois cálculos diferentes:</p>
                        
                        <iframe width="800" height="400" frameborder="0" 
                                src="http://pythontutor.com/iframe-embed.html#code=import%20math%0A%09%0Adef%20f%28x%29%3A%0A%20%20%20%20if%200%20%3C%3D%20x%20%3C%3D%20math.pi%3A%0A%20%20%20%20%20%20%20%20return%20math.sin%28x%29%0A%20%20%20%20else%3A%0A%20%20%20%20%20%20%20%20return%200%0A%0Aprint%20f%280.5%29%0Aprint%20f%285*math.pi%29&codeDivHeight=400&codeDivWidth=350&cumulative=false&curInstr=12&heapPrimitives=false&origin=opt-frontend.js&py=2&rawInputLstJSON=%5B%5D&textReferences=false"> 
                        </iframe>
                        
                        
                    </div>                    
                    <div class="bs-docs-section" id="if_geral">
                        <h1 class="page-header">Forma geral de testes <code>if</code></h1>

                        <p>A forma geral de escrita é: se-senão, no código <code>if-else</code>,
                            sendo que o <code>else</code> é opcional.</p>
                        
                        <pre><code class="language-python">
if condicional:
    &lt;bloco de declarações, executados quando a condição no if é True&gt;
else:
    &lt;bloco de declarações, executados quando a condição no if é False&gt;
                        </code></pre>
                        
                        <p>Também é possível um composição com múltiplos <code>if-else</code>:</p>
                        
                        <pre><code class="language-python">
if condicional1:
    &lt;bloco de declarações&gt;
elif condicional2:
    &lt;bloco de declarações&gt;
elif condicional3:
    &lt;bloco de declarações&gt;
else:
    &lt;bloco de declarações&gt;
&lt;próxima declaração&gt;
                        </code></pre>
                        
                    </div>
                    <div class="bs-docs-section" id="multipla_ramificacao_ex">
                        <h1 class="page-header">Exemplo com múltipla ramificação</h1>

                        <p>Uma função definida por partes:</p>
                        
                        $$
                        N(x) = \left\lbrace\begin{array}{ll}
                        0, & x < 0\\
                        x, & 0\leq x < 1\\
                        2-x, & 1\leq x < 2\\
                        0, & x \geq 2
                        \end{array}\right.
                        $$
                        
                        <p>A implementação em Python com múltiplas ramificações 
                            com <code>if-else</code>:</p>
                        
                        <pre><code class="language-python">
def N(x):
    if x < 0:
        return 0
    elif 0 <= x < 1:
        return x
    elif 1 <= x < 2:
        return 2 - x
    elif x >= 2:
        return 0
                        </code></pre>
                        
                    </div>
                    <div class="bs-docs-section" id="testes_if_emlinha">
                        <h1 class="page-header">Testes <code>if</code> em
                        linha para códigos mais curtos</h1>

                        <p>Construção padrão:</p>
                        
                        <pre><code class="language-python">
if condicional:
    variavel = valor1
else:
    variavel = valor2
                        </code></pre>
                        
                        <p>Sintaxe mais compacta com <code>if-else</code>
                        em uma linha:</p>
                        
                        <pre><code class="language-python">
variavel = (valor1 if condicional else valor2)
                        </code></pre>

                        <p>Exemplo:</p>
                        <pre><code class="language-python">
def f(x):
    return (sin(x) if 0 <= x <= 2*pi else 0)
                        </code></pre>
                        
                    </div>
                    <div class="bs-docs-section" id="funcoes_teste_especiais">
                        <h1 class="page-header">Funções de teste de funções</h1>

                        <p>Vamos escrever funções de teste especiais para
                        verificar outras funções:</p>
                        
                        <pre><code class="language-python">
def dobrar(x):            #uma função qualquer
    return 2*x

def test_dobrar():        #função de teste associada
    """Chama dobrar(x) para checar se ela funciona."""
    x = 4                 #alguns valores de x escolhidos
    esperado = 8          #resultado esperado da função dobrar(x)
    calculado = dobrar(x)
    sucesso = calculado == esperado  #valor condicional: o teste passou?
    msg = 'calculado %s, esperado %s' % (calculado, esperado)
    assert sucesso, msg
                        </code></pre>
                        
                        <p>Regras para funções teste:</p>
                        <ul>
                            <li>o nome inicia em <i>test_</i>;</li>
                            <li>sem argumentos;</li>
                            <li>deve ter uma declaração de sucesso <code>assert</code>, onde 
                                o sucesso é <code>True</code> se o teste passou
                                e <code>False</code> se não. A linha <code>assert sucesso, msg</code>
                                imprime a mensagem <code>msg</code> junto com o levantamento
                            do erro quando o teste falha.</li>
                        </ul>
                        
                    </div>
                    <div class="bs-docs-section" id="funcoes_teste_varios_testes">
                        <h1 class="page-header">Funções teste com vários testes</h1>

                        <pre><code class="language-python">
def dobrar(x):            #alguma função
    return 2*x

def test_dobrar():        #função teste associada
    tol = 1E-14           #tolerância para comparação de ponto flutuante
    valores_x =        [3, 7,  -2, 0, 4.5]
    valores_esperados = [6, 14, -4, 0,   9]
    for x, esperado in zip(valores_x, valores_esperados):
        calculado = dobrar(x)
        msg = '%s != %s' % (calculado, esperado)
        assert abs(esperado - calculado) < tol, msg
                        </code></pre>
                        
                        <p>A função teste vai rodar silenciosamente se todos os testes
                            passarem. Se um dos testes acima falhar, o <code>assert</code>
                            vai levantar um erro de afirmação (<code>AssertionError</code>).</p>
                        
                    </div>
                    <div class="bs-docs-section" id="regras_funcoes_teste">
                        <h1 class="page-header">Porque escrever funções teste de acordo com 
                        essas regras?</h1>

                        <ul>
                            <li>Fácil de reconhecer onde funções são verificadas;</li>
                            <li>Bibliotecas de teste, como <i>nose</i> e <i>pytest</i>
                            podem rodar automaticamente todas as suas funções teste
                            (em uma árvore de diretórios) e reportar algum erro
                            que tenha passado desapercebido.</li>
                            <li>Essa é uma regra padrão muito bem estabelecida.</li>
                        </ul>
                        
                        <p>Recomenda-se o uso do <i>pytest</i> por ter uma saída
                        melhor.</p>
                        
                        <p><b>Unidades de teste</b></p>
                        <p>Funções de teste como <code>test_dobrar()</code> é frequentemente
                            referenciada como unidade de teste (<i>test unit</i>)
                        pois testa uma pequena parte (função) do programa. Quando
                        todas as unidades de teste funcionam, o programa supostamente
                        deve funcionar.</p>
                        
                    </div>
                    
                    <div class="bs-docs-section" id="final">
                        <h1 class="page-header">Tarefa</h1>
                        <p>A Integral</p>                        
                        
                        $$
                        \int_a^b f(x)dx
                        $$
                        
                        <p>pode ser aproximada pela <em>regra de Simpson</em>:</p>
                        
                        $$
                        \int_a^b f(x)dx \approx {b-a\over 3n}\biggl(
                         f(a) + f(b) + 4\sum_{i=1}^{n/2} f(a + (2i-1)h)
                         + 2\sum_{i=1}^{n/2-1} f(a+2ih)\biggr)
                        $$
                        
                        <p><b>Problema:</b></p>
                        <p>Faça uma função
                        <code>Simpson(f, a, b, n=500)</code>
                        para calcular a integral de $f(x)$ pela regra de Simpson,
                        sendo $f(x)$:</p>
                        $$ {3\over2}\int_0^\pi\sin^3 \theta d\theta $$
                        <p>(valor exato: 2) para \( n=2,6,12,100,500 \).</p>
                        
                        <p>Use funções de verificação (mais de uma) para verificar se a 
                        função <code>Simpson(f, a, b, n=500)</code> está
                        integrando corretamente.</p>


                        <!--SOLUÇÃO DA TAREFA-->
                        <button type="button" class="btn btn-info disabled">Solução</button>                        
                        <!--<button type="button" class="btn btn-info" data-toggle="collapse" data-target="#tarefa">Solução</button>-->
                        <!--Final solução da tarefa-->                        

                        <div id="tarefa" class="collapse">
                            <h3> Exemplo de solução: </h3>

                            <pre><code class="language-python">
import math

def Simpson(f, a, b, n=500):
    """
    Retorna a aproximação da integral de f
    de a a b usando a regra de Simpson com n intervalos.
    """
    if a > b:
        print 'Erro: a=%g > b=%g' % (a, b)
        return None

    #Checando se n é par
    if n % 2 != 0:
        print 'Erro: n=%d não é um inteiro par!' % n
        n = n+1  #fazendo n par

    h = (b - a)/float(n)
    soma1 = 0
    for i in range(1, n/2 + 1):
        soma1 += f(a + (2*i-1)*h)

    soma2 = 0
    for i in range(1, n/2):
        soma2 += f(a + 2*i*h)

    integral = (b-a)/(3*n)*(f(a) + f(b) + 4*soma1 + 2*soma2)
    return integral

def h(x):
    return (3./2)*math.sin(x)**3

def aplicacao():
    print 'Integral de 1.5*sen^3 de 0 a pi:'
    for n in 2, 6, 12, 100, 500:
        aprox = Simpson(h, 0, math.pi, n)
        print 'n=%3d, aprox=%18.15f, erro=%9.2E' % \
              (n, aprox, 2-aprox)

def test_Simpson():
    """Verifica se o polinomil g de segunda ordem foi integrado exatamente."""
    a = 1.5
    b = 2.0
    n = 8
    g = lambda x: 3*x**2 - 7*x + 2.5       #teste do integrando
    G = lambda x: x**3 - 3.5*x**2 + 2.5*x  #integral de g
    exato = G(b) - G(a)
    aprox = Simpson(g, a, b, n)
    sucesso = abs(exato - aprox) < 1E-14  #NUNCA USE == PARA PONTOS FLUTUANTES!
    msg = 'Não é possível integrar uma função quadrática exatamente'
    assert sucesso, msg

def experimentos():
    """Alguns outros testes com respostas conhecidas."""
    n = 200
    print 'sen de 0 a pi:', Simpson(math.sin, 0, math.pi, n)
    print 'exp de 0 a log(3):', Simpson(math.exp, 0, math.log(3), n)

test_Simpson()
aplicacao()
experimentos()
</code></pre>
                        </div>

                    </div>
                    
                </div>
                <!-- FINAL Conteúdo Principal -->
                
                <!-- Menu lateral -->
                <div class="col-md-3" role="complementary"> 
                    <nav class="bs-docs-sidebar hidden-print hidden-sm hidden-xs affix-top" id="menuLateral"> 
                        <ul class="nav bs-docs-sidenav"> 
                            <li><a href="#inicio">Funções e Ramificações</a></li>
                        </ul> 
                        <a href="#top" class="back-to-top"> Voltar ao topo </a>                 
                    </nav> 
                </div>
                <!-- FINAL Menu lateral -->
                
            </div>
        </div>
        <!-- FINALParte principal -->
        
        <!-- Rodapé -->
        <footer class="bs-docs-footer"> 
            <div class="container"> 
                <ul class="bs-docs-footer-links"> 
                    <li><a href="http://www.estruturas.ufpr.br" target="_blank">estruturas.UFPR</a></li> 
                    <li><a href="http://www.estruturas.ufpr.br/disciplinas/pos-graduacao/introducao-a-computacao-cientifica-com-python/" target="_blank">Introdução à computação científica</a></li> 
                    <li><a href="https://www.python.org/" target="_blank">Python.org</a></li> 
                    <li><a href="https://www.python.org/dev/peps/pep-0257/" target="_blank">Docstring Conventions</a></li> 
                </ul> 
                <p>
                    Prof. Marco André Argenta
                </p> 
            </div> 
        </footer>
        <!-- FINAL Rodapé -->        
        
        <script src="../adicionais/jquery.min.js"></script>
        <script src="../adicionais/bootstrap.min.js"></script>
        <script src="./js/docs.min.js"></script>
        <script src="./js/prism.js"></script>
    </body>
</html>
